package search;
import java.io.BufferedReader;
import java.util.concurrent.LinkedBlockingQueue;

public class Manager {
    
    public static LinkedBlockingQueue<String> search1(BufferedReader data, String query, int num)
        throws InterruptedException{
        LinkedBlockingQueue<String> result = new LinkedBlockingQueue<String>();
        Searcher s = new Searcher(data,query,result);
        s.setName("1");
        s.start();
        Thread.sleep(100);
        s.printStatus();
        return result;
    }
    
    public static LinkedBlockingQueue<String> search(BufferedReader data, String query, int num){
        try{
            return search1(data,query,num);
        }
        catch (InterruptedException e){
            System.out.println("Search interrupted.");
            throw new RuntimeException("Unexpected search interruption");
        }
    }
}
